Bug 93358 - [HSW] Unreal Elemental demo - assertion error in copy_image_with_blitter
Summary: [HSW] Unreal Elemental demo - assertion error in copy_image_with_blitter
Status: RESOLVED FIXED
Alias: None
Product: Mesa
Classification: Unclassified
Component: Drivers/DRI/i965 (show other bugs)
Version: git
Hardware: Other All
: medium normal
Assignee: Ian Romanick
QA Contact: Intel 3D Bugs Mailing List
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2015-12-11 21:06 UTC by Ilia Mirkin
Modified: 2016-02-11 19:46 UTC (History)
3 users (show)

See Also:
i915 platform:
i915 features:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Ilia Mirkin 2015-12-11 21:06:45 UTC
A couple of frames in I get:

ElementalDemo: intel_copy_image.c:83: copy_image_with_blitter: Assertion `src_width % bw == 0' failed.

mesa commit 79bff488bc
Haswell gpu: 00:02.0 VGA compatible controller [0300]: Intel Corporation Xeon E3-1200 v3/4th Gen Core Processor Integrated Graphics Controller [8086:0412] (rev 06)

DRI3-enabled DDX (in case it matters).

Demo downloadable from https://wiki.unrealengine.com/Linux_Demos

Run like this: ./ElementalDemo ResX=640 ResY=480
Comment 1 Ilia Mirkin 2015-12-13 16:55:10 UTC
I wonder if this is related to my ARB_copy_image fix:

commit 912babba7bf1abd3caa49f6372d581ae1afe7e84
Author: Ilia Mirkin <imirkin@alum.mit.edu>
Date:   Sun Nov 8 04:46:38 2015 -0500

    mesa/copyimage: allow width/height to not be multiples of block
Comment 2 Jason Ekstrand 2016-01-08 05:37:38 UTC
(In reply to Ilia Mirkin from comment #1)
> I wonder if this is related to my ARB_copy_image fix:
> 
> commit 912babba7bf1abd3caa49f6372d581ae1afe7e84
> Author: Ilia Mirkin <imirkin@alum.mit.edu>
> Date:   Sun Nov 8 04:46:38 2015 -0500
> 
>     mesa/copyimage: allow width/height to not be multiples of block

Quite possibly.  Mind actually bisecting (or just checking either side of that commit) or are you going to make us do it? :-)

Looking at that assert, we probably just need to remove the width and height asserts and use DIV_ROUND_UP instead of regular divide.
Comment 3 Ilia Mirkin 2016-01-08 05:44:00 UTC
(In reply to Jason Ekstrand from comment #2)
> (In reply to Ilia Mirkin from comment #1)
> > I wonder if this is related to my ARB_copy_image fix:
> > 
> > commit 912babba7bf1abd3caa49f6372d581ae1afe7e84
> > Author: Ilia Mirkin <imirkin@alum.mit.edu>
> > Date:   Sun Nov 8 04:46:38 2015 -0500
> > 
> >     mesa/copyimage: allow width/height to not be multiples of block
> 
> Quite possibly.  Mind actually bisecting (or just checking either side of
> that commit) or are you going to make us do it? :-)

I was hoping you guys could work it out. Not sure when I'll be in front of the HSW machine next... probably Monday. I was mostly testing that demo on an NVIDIA GK208 board (where it used to have artifacts, all good now - commit 7752bbc44e fixed it right up), and ran it against Intel "just to see what happens". This happened, figured it was of interest.
Comment 4 Jason Ekstrand 2016-01-08 06:25:36 UTC
(In reply to Ilia Mirkin from comment #3)
> I was hoping you guys could work it out. Not sure when I'll be in front of
> the HSW machine next... probably Monday. I was mostly testing that demo on
> an NVIDIA GK208 board (where it used to have artifacts, all good now -
> commit 7752bbc44e fixed it right up), and ran it against Intel "just to see
> what happens". This happened, figured it was of interest.

That's fine.  Thanks for the bug report none-the-less.  Like I said above, I'm sure it's an easy fix.  Just need to find time to fix it.
Comment 5 Ben Widawsky 2016-02-11 19:46:06 UTC
commit 088280e022bca10c3712dfa6f8e0ff343a37ce77
Author: Ben Widawsky <benjamin.widawsky@intel.com>
Date:   Sat Feb 6 18:11:21 2016 -0800

    i965: Make sure we blit a full compressed block


bug/show.html.tmpl processed on Jan 16, 2017 at 19:17:56.
(provided by the Example extension).